% StroopStimResponse.m
% This program presents stroop like stimuli and record keypress response.
% Written by YW, 2022


function MyEmotionalStroopExpF2(id,name,session)
Screen('Preference', 'Verbosity', 0);
Screen('Preference', 'SkipSyncTests',1);
Screen('Preference', 'VisualDebugLevel',0);

try
    for se=1:session%ʵִ
        subid=num2str(id);%ʶ
        subname=name;
        %Ա--̼߿ɫ
        folder_path = 'D:\MATLABϴ\ɳ̲_files';
        file_names = dir(fullfile(folder_path, '*.jpg')); % ȡļ.jpgʽͼƬļ
        images = cell(size(file_names));% һļͬcell
        for i = 1:length(file_names)
            images{i} = imread(fullfile(folder_path, file_names(i).name));
        end
        %ͼƬԤСһ
        processed_images = cell(size(images));
        for i = 1:length(images)
            processed_images{i} = imresize(images{i}, [680 680]); % ͼƬΪ680x680С
            
        end
        StimColor={[255 0 0];[0 0 255]};
        count=0;
        BlockNum=2;% how may block in this experiment
        for i=1:length(processed_images)%һѭprocessed_imagesԪءѭi1ʼֱprocessed_imagesĳȣԪظ
            for j=1:length(StimColor)%һѭprocessed_imagesԪءѭi1ʼֱprocessed_imagesĳȣԪظ
                count=count+1;%ÿڲѭʱcountֵ1ԱΪһԪطµ
                Stim(count).processed_images =processed_images{i}; % ǰѭеprocessed_imagesĵiԪظֵStim(count).processed_imagesṹ
                Stim(count).color=StimColor{j};% ǰѭеprocessed_imagesĵiԪظֵStim(count).processed_images
            end
        end
        %
        results.images= NaN*ones(BlockNum,length(Stim));
        results.color = NaN*ones(BlockNum,length(Stim));
        results.response = NaN*ones(BlockNum,length(Stim));
        results.reactiontime = NaN*ones(BlockNum,length(Stim));
        
        %%%һָĴ
        % predefine parametersԤ
        BlockNum=2;% how may block in this experiment
        StimDuration=2000;% 2000ms
        ISImin=1000;% the minmum interstimulus interval (ISI)
        ISImax=1500;% the maxmum interstimulus interval (ISI)
        TxtSize=80;% the size of the texts
        TxtFont='SimSun'; % the font of the texts
        
        
        
        % open window
        screenNum=0;
        [wPtr,rect]=Screen('OpenWindow',screenNum);
        HideCursor;
        black=BlackIndex(wPtr);
        white=WhiteIndex(wPtr);
        monitorFlipInterval=Screen('GetFlipInterval', wPtr);
        hz=FrameRate(wPtr);
        StimDuration=round((StimDuration/1000)*hz);
        ISIrange=round(((ISImax-ISImin)/1000)*hz);
        ISImin=round((ISImin/1000)*hz);
        ISI=round(rand(BlockNum,length(Stim))*ISIrange+ISImin);%һļ飬ÿļСںڵķΧڡ
        
        %Ԥ
        starttime=Screen('Flip',wPtr); % collect the time for the first flip with starttime
        Screen('TextSize', wPtr , TxtSize);
        Screen( 'TextFont', wPtr ,TxtFont);
        Fornt1Rect= Screen('TextBounds',wPtr,'Welcome to the experiment!');
        Fornt1Loc=[round(rect(3)/2-Fornt1Rect(3)/2),round(rect(4)/6-Fornt1Rect(4)/4)];
        Screen('DrawText', wPtr,'Welcome to the experiment!', Fornt1Loc(1), Fornt1Loc(2));
        
        TxtSize1=TxtSize/4;
        Screen('TextSize', wPtr , TxtSize1);
        Screen( 'TextFont', wPtr ,TxtFont);
        Text2Rect= Screen('TextBounds',wPtr,'Welcome to the experiment! When you see the color of the border is');
        Text3Rect= Screen('TextBounds',wPtr,'"red", press the "f" key, "blue" press the "k" key.');
        Text4Rect= Screen('TextBounds',wPtr,'If there is no doubt, press the space bar to start the experiment.');
        Fornt2Loc=[round(rect(3)/2-Text2Rect(3)/2),round(rect(4)/2-Text2Rect(4)/4)];
        Fornt3Loc=[round(rect(3)/2-Text3Rect(3)/2),round(rect(4)/2+Text3Rect(4))];
        Fornt4Loc=[round(rect(3)/2-Text4Rect(3)/2),round(rect(4)/2+2*Text4Rect(4))];
        
        Screen('DrawText', wPtr,'Welcome to the experiment! When you see the color of the border is', Fornt2Loc(1), Fornt2Loc(2));
        Screen('DrawText', wPtr,'"red", press the "f" key, "blue" press the "k" key.', Fornt3Loc(1), Fornt3Loc(2));
        Screen('DrawText', wPtr,'If there is no doubt, press the space bar to start the experiment.', Fornt4Loc(1), Fornt4Loc(2));
        Screen('Flip',wPtr);
        
        %         keyCode=NaN;
        %%%һֽڶֵĴ
        ListenChar(2);
        while 1
            [ ~, ~, keyCode] = KbCheck;%KbCheckȡǰ״̬Ͱ
            while ~strcmp(KbName(keyCode),'space')
                [~,~, keyCode ] = KbCheck;%¿ոʱѭ
            end
            break
        end
        while KbCheck; end
        ListenChar(0);
        starttime=Screen('Flip',wPtr);
        starttime=Screen('Flip',wPtr,starttime+2);
        starttime=Screen('Flip',wPtr);
        %%ڶͼƬ߿ɫ̼ӦȷѡĴ
        
        for ii=1:BlockNum%ѭͬϣ2block
            %̼
            Screen('TextSize', wPtr , TxtSize);
            Screen( 'TextFont', wPtr ,TxtFont);
            StimRand=Stim(randperm(length(Stim))); %̼
            for jj=1:length(Stim)
                %%
                %%߿
                Screen('FillRect',wPtr,StimRand(jj).color,[(rect(3)/2 - 400) (rect(4)/2 - 400) (rect(3)/2 + 400) (rect(4)/2 + 400)]);%߿Сã棩
                %%
                %%%չʾͼƬ̼
                textureIndex=Screen('MakeTexture', wPtr, StimRand(jj).processed_images);%
                Screen('PreloadTextures', wPtr, textureIndex);%
                Screen('DrawTexture', wPtr, textureIndex );%
                Screen(wPtr, 'Flip');%ת
                
                keys = {};%һյֵ䣬ڴ洢Ϣ
                RT = [];%һյ飬ڴ洢Ӧʱ
                ListenChar(2);%룬2ʾַֻ
                nKeys = 0;%ʼΪ0
                results.color(ii,jj)=find(StimRand(jj).color~=0); %ҵStimRand(jj).colorв0Ԫأֵ
                %ʱ䡢ѭ  Ϣ洢
                while GetSecs-starttime < StimDuration*monitorFlipInterval %Ҫڹ涨ʱжϣѭֱﵽ̼ʱĻˢ¼
                    [keyIsDown, timeSecs, keyCode ] = KbCheck;%Ƿа
                    if keyIsDown
                        nKeys = nKeys+1;%£Ӱ
                        RT(nKeys) = timeSecs-starttime;%㰴ʱ洢Ӧʱ
                        keys{nKeys} = KbName(keyCode);%ƴ洢ֵ
                        %ѭ
                        while KbCheck;%KbCheckΪ棨а£ʱѭһֱִ
                        end
                        %ʾĴ
                        if (strcmp(keys{nKeys},'f') && results.color(ii,jj)==1)...%ͬһз...
                                ||(strcmp(keys{nKeys},'k') && results.color(ii,jj)==3)%3ָǡ0 0 255з0λ
                            Screen('TextSize', wPtr , TxtSize);
                            Screen( 'TextFont', wPtr ,TxtFont);
                            TxtRect= Screen('TextBounds',wPtr,'Right'); % get the size of each stimulus text
                            TxtLoc=[round(rect(3)/2-TxtRect(3)/2),round(rect(4)/2-TxtRect(4)/2)];%make the text in the middle of the screen
                            Screen('DrawText', wPtr, 'Right', TxtLoc(1), TxtLoc(2),[0 255 0]);
                            Screen(wPtr, 'Flip');
                            starttime=Screen(wPtr, 'Flip', starttime+2);
                            break
                        else
                            Screen('TextSize', wPtr , TxtSize);
                            Screen( 'TextFont', wPtr ,TxtFont);
                            TxtRect= Screen('TextBounds',wPtr,'Wrong'); % get the size of each stimulus text
                            TxtLoc=[round(rect(3)/2-TxtRect(3)/2),round(rect(4)/2-TxtRect(4)/2)];%make the text in the middle of the screen
                            Screen('DrawText', wPtr, 'Wrong', TxtLoc(1), TxtLoc(2),[255 0 0]);
                            Screen(wPtr, 'Flip');
                            starttime=Screen(wPtr, 'Flip', starttime+2);
                            break
                        end
                    end
                end
                
                starttime=Screen('Flip', wPtr);% time in secs
                
                %ͼƬϢ洢
                if StimRand(jj). processed_images == processed_images{1}
                    results.images(ii,jj)=1;% pic1
                elseif StimRand(jj). processed_images == processed_images{2}
                    results.images(ii,jj)=2;% pic2
                elseif StimRand(jj). processed_images == processed_images{3}
                    results.images(ii,jj)=3;% pic3
                elseif StimRand(jj). processed_images == processed_images{4}
                    results.images(ii,jj)=4;% pic4
                elseif StimRand(jj). processed_images == processed_images{5}
                    results.images(ii,jj)=5;% pic5
                elseif StimRand(jj). processed_images == processed_images{6}
                    results.images(ii,jj)=6;% pic6
                elseif StimRand(jj). processed_images == processed_images{7}
                    results.images(ii,jj)=7;% pic7
                elseif StimRand(jj). processed_images == processed_images{8}
                    results.images(ii,jj)=8;% pic8
                end
                results.color(ii,jj)=find(StimRand(jj).color~=0); % color 1=red,2=green, 3=blue
                %Ӧʱ/Ϣ洢
                if ~isempty(RT)
                    results.reactiontime(ii,jj)=RT;
                    results.key{ii,jj}=keys{1};
                    
                    if (results.key{ii,jj}=='f' && results.color(ii,jj)==1)...
                            ||(results.key{ii,jj}=='k' && results.color(ii,jj)==3)
                        results.response(ii,jj) = 1;
                    else
                        results.response(ii,jj) = 0;
                    end
                end
            end
        end
        ISIlast=round(rand(1)*ISIrange+ISImin); % the last trial's ISI
        % blank the screen and wait a second
        Screen('FillRect',wPtr,white);
        Screen(wPtr, 'Flip', starttime+(ISIlast*monitorFlipInterval+1));%FlipInterval  (Speed)=(Distance)/ʱ(Time)λΪÿ(m/s, meterspersecond, mps);
        %ͬ֡(Frame rate)=֡(Frames)/ʱ(Time)λΪ֡ÿ(f/s, frames per second, %fps)1֡=1/֡
        
        % save the datafile to disc for each participant
        datafile=['StroopData_Sub' num2str(se)];
        path=pwd;
        save ([path 'D:\MATLABϴ\StroopData_Sub' datafile '.mat'], 'results'); % save as mat file
    end
    
    %%%һָֽĴ
    starttime=Screen('Flip',wPtr); % collect the time for the first flip with starttime
    Screen('TextSize', wPtr , TxtSize);
    Screen( 'TextFont', wPtr ,TxtFont);
    Fornt1Rect= Screen('TextBounds',wPtr,'Thank you!!!');
    Fornt1Loc=[round(rect(3)/2-Fornt1Rect(3)/2),round(rect(4)/6-Fornt1Rect(4)/2)];
    Screen('DrawText', wPtr,'Thank you!!!', Fornt1Loc(1), Fornt1Loc(2));
    
    TxtSize1=TxtSize/4;
    Screen('TextSize', wPtr , TxtSize1);
    Screen( 'TextFont', wPtr ,TxtFont);
    Text2Rect= Screen('TextBounds',wPtr,'The experiment is finished');
    Text3Rect= Screen('TextBounds',wPtr,'If you have some quetion,ask the worker');
    Text4Rect= Screen('TextBounds',wPtr,'If there is no doubt,you can press the SPACE bar and leave now');
    Fornt2Loc=[round(rect(3)/2-Text2Rect(3)/2),round(rect(4)/2-Text2Rect(4)/4)];
    Fornt3Loc=[round(rect(3)/2-Text3Rect(3)/2),round(rect(4)/2+Text3Rect(4))];
    Fornt4Loc=[round(rect(3)/2-Text4Rect(3)/2),round(rect(4)/2+2*Text4Rect(4))];
    
    Screen('DrawText', wPtr,'The experiment is finished', Fornt2Loc(1), Fornt2Loc(2));
    Screen('DrawText', wPtr,'Thanks   for   the   experiment.  Bye!!!', Fornt3Loc(1), Fornt3Loc(2));
    Screen('DrawText', wPtr,'If there is no doubt,you can press the SPACE bar and leave now', Fornt4Loc(1), Fornt4Loc(2));
    %ո񰴼˳Ĵ
    starttime=Screen('Flip',wPtr);
    ListenChar(2);
    while 1
        [ keyIsDown, ~, keyCode ] = KbCheck;
        if keyIsDown
            while ~strcmp(KbName(keyCode),'space');[ ~, ~, keyCode ] = KbCheck; end
            break
        end
    end
    ListenChar(0);
    starttime=Screen('Flip',wPtr);
    Screen('CloseAll');
    ShowCursor
catch
    Screen('CloseAll')
    ListenChar(0);
    ShowCursor
    rethrow(lasterror)
end
end